import abc

from django.utils import six


@six.add_metaclass(abc.ABCMeta)
class BaseAttributeSource(object):
    '''
    Base class for attribute sources
    '''
    @abc.abstractmethod
    def get_instances(self, ctx):
        pass

    @abc.abstractmethod
    def get_attribute_names(self, instance, ctx):
        pass

    @abc.abstractmethod
    def get_attributes(self, instance, ctx):
        pass

    @abc.abstractmethod
    def get_dependencies(self, instance, ctx):
        pass
